'use strict';

/**
 * Read the documentation (https://strapi.io/documentation/developer-docs/latest/development/backend-customization.html#core-controllers)
 * to customize this controller
 */
const url = require('url');
const request = require('request');
const { sanitizeEntity, webhook } = require('strapi-utils');
const { isDraft } = require('strapi-utils').contentTypes;

module.exports = {
	// SN 25-11-2021 AP
    async groupline(ctx) {
    	var uid = ctx.params.uid;
    	if(uid){
        	const result = await strapi.query('groupline').model.query(qb => { qb.where('groupline_user_uid', uid) }).fetchAll();
        	const _resp = sanitizeEntity(result, { model: strapi.models.groupline })
        	ctx.send(_resp);
        }else{ctx.send([])}
    },
	// EN 25-11-2021 AP

	// SN 25-11-2021 AP | สร้างกลุ่ม
    async callback(ctx) {   
        // https://127.0.0.1:4200/callback?code=9W1DoxCjQMtL4bQ5A2sb5Z&state=mybot1
		const current_url = new URL(ctx.request.href);
		// get access to URLSearchParams object
		const search_params = current_url.searchParams;
		// get url parameters
		const _code = search_params.get('code');
		const _state = search_params.get('state'); // UID | ID 
		// request data to line notify
		const _query = async function (options) { 
		  return new Promise((resolve, reject) => {
		    request(options, (error, response, body) => {
		      if (response) {
		        return resolve(response);
		      }
		      if (error) {
		        return reject(error);
		      }
		    });
		  });
		};
		//create Token Line
		var options = {
		  'method': 'POST',
		  'url': 'https://notify-bot.line.me/oauth/token',
		  'headers': { },
		  formData: {
		    'grant_type': 'authorization_code',
		    'code': _code,
			'redirect_uri': 'http://localhost:3000/callback',// 'redirect_uri': 'https://liff.at-mybot.me/callback',
		    'client_id': 'iVYzCt1Ig1xBkPgdhO61l6',
		    'client_secret': 'VTQEFFsEdNa4C0kzwqxB72da65sJAnvcWbCxc90dBIl'
		  }
		};
    	let response = await _query(options);
		// {  "status" : 400,  "message" : "invalid code",  "access_token" : null }
    	try {
  			var _res = JSON.parse(response.body);
			var options2 = {
				'method': 'GET',
				'url': 'https://notify-api.line.me/api/status',
				'headers': {'Authorization': 'Bearer '+_res.access_token }
			};
			let response2 = await _query(options2);
        	// {"status":200,"message":"ok","targetType":"USER","target":"มายบอท (ฝ่ายขาย)"}
        	// {"status":200,"message":"ok","targetType":"GROUP","target":"! บอทป้องกัน V5"}
			try {
            	//	 ออก token ได้
				var _res2 =  JSON.parse(response2.body);
            	// Save New Group|User
            	const entry = await strapi.query('groupline').create({
					"groupline_name": _res2.target,
					"groupline_key_notify": _res.access_token,
					"groupline_user_uid": _state, // uid
					"groupline_keycode": _code, // code create to token
            	});            
				ctx.redirect('https://127.0.0.1:4200/rent-item/'+entry.id)
			} catch (error) {
				console.error(error);
				ctx.send('{"status" : "Error เนื่องจากไม่สามารถดึงชื่อกลุ่มได้"}');  
			}

		} catch (error) {
  			console.error(error);
        	ctx.send('{"status" : "Error เนื่องจากไม่สามารถออก Token ได้"}');  
		}

    },
	// EN 25-11-2021 AP

	// SN 30-11-2021 AP
	async update_groupline(ctx) {
    	// input param
		var id = ctx.request.body.item_id; // กลุ่ม
		var item_id = ctx.request.body.item_product_id; // product อัพเดท
		var item_header = ctx.request.body.item_new_name; // ชื่อที่ต้องการเปลี่ยน
		var item_comment = ctx.request.body.item_comment; // ข้อความท้ายผล

		var result = await strapi.query('groupline').model.query(qb => { qb.where('id', id) }).fetchAll();
    	var _resp = sanitizeEntity(result, { model: strapi.models.groupline });
    	var _item = _resp[0].item;
    	var _new_item = [];
    	_item.forEach(products => {
        	if(products.id == item_id){
				if (item_header != undefined) {
					products.items_header = item_header; //เปลี่ยนชื่อใหม่
				} else if (item_comment != undefined){
					products.items_comment = item_comment; //ข้อความท้ายผล
				}
            }
        	_new_item.push(products);
		});
		var dataset = {
			"id" : id,
			"item": _new_item
		}
		console.log(dataset);
		strapi.query('groupline').update({ id: id }, dataset);
		ctx.send({"status" : true});
  	},
	// EN 30-11-2021 AP

	// SN 02-08-2029 AP | Path : update-groupline/mode
	async update_mode(ctx){
		console.log(ctx.request.body);

		var id = ctx.request.body.item_id; // กลุ่ม
		var item_id = ctx.request.body.item_product_id; // product อัพเดท

		var items_status_5 = ctx.request.body.items_status_5;
		var items_status_10 = ctx.request.body.items_status_10;
		var items_status_15 = ctx.request.body.items_status_15;

		var items_theme_5 = ctx.request.body.items_theme_5;
		var items_theme_10 = ctx.request.body.items_theme_10;
		var items_theme_15 = ctx.request.body.items_theme_15;

		var items_view_5 = ctx.request.body.items_view_5;
		var items_view_10 = ctx.request.body.items_view_10;
		var items_view_15 = ctx.request.body.items_view_15;

		var result = await strapi.query('groupline').model.query(qb => { qb.where('id', id) }).fetchAll();
		var _resp = sanitizeEntity(result, { model: strapi.models.groupline });
		var _item = _resp[0].item;
		var _new_item = [];
		_item.forEach(products => {
			if (products.id == item_id) {

				if (items_status_5 != undefined) { products.items_status_5 = items_status_5;}
				if (items_status_10 != undefined) { products.items_status_10 = items_status_10; }
				if (items_status_15 != undefined) { products.items_status_15 = items_status_15; }

				if (items_theme_5 != undefined) { products.items_theme_5 = items_theme_5; }
				if (items_theme_10 != undefined) { products.items_theme_10 = items_theme_10; }
				if (items_theme_15 != undefined) { products.items_theme_15 = items_theme_15; }

				if (items_view_5 != undefined) { products.items_view_5 = items_view_5; }
				if (items_view_10 != undefined) { products.items_view_10 = items_view_10; }
				if (items_view_15 != undefined) { products.items_view_15 = items_view_15; }

			}
			_new_item.push(products);
		});
		var dataset = {
			"id": id,
			"item": _new_item
		}
		console.log(dataset);
		strapi.query('groupline').update({ id: id }, dataset);
		ctx.send({ "status": true });
	},
	// EN 02-08-2029 AP

	// SN 02-08-2029 AP | Path : update-groupline/block
	async update_block(ctx) {
		console.log(ctx.request.body);

		var id = ctx.request.body.item_id; // กลุ่ม
		var item_id = ctx.request.body.item_product_id; // product อัพเดท

		var items_block = ctx.request.body.items_block;

		var result = await strapi.query('groupline').model.query(qb => { qb.where('id', id) }).fetchAll();
		var _resp = sanitizeEntity(result, { model: strapi.models.groupline });
		var _item = _resp[0].item;
		var _new_item = [];
		_item.forEach(products => {
			if (products.id == item_id) {

				if (items_block != undefined) { products.items_block = items_block; }

			}
			_new_item.push(products);
		});
		var dataset = {
			"id": id,
			"item": _new_item
		}
		console.log(dataset);
		strapi.query('groupline').update({ id: id }, dataset);
		ctx.send({ "status": true });
	},
	// EN 02-08-2029 AP

	// SN 02-08-2029 AP | Path : update-groupline/alert
	async update_alert(ctx) {
		console.log(ctx.request.body);

		var id = ctx.request.body.item_id; // กลุ่ม
		var item_id = ctx.request.body.item_product_id; // product อัพเดท

		var items_alert = ctx.request.body.items_alert;

		var result = await strapi.query('groupline').model.query(qb => { qb.where('id', id) }).fetchAll();
		var _resp = sanitizeEntity(result, { model: strapi.models.groupline });
		var _item = _resp[0].item;
		var _new_item = [];
		_item.forEach(products => {
			if (products.id == item_id) {

				if (items_alert != undefined) { products.items_alert = items_alert; }

			}
			_new_item.push(products);
		});
		var dataset = {
			"id": id,
			"item": _new_item
		}
		console.log(dataset);
		strapi.query('groupline').update({ id: id }, dataset);
		ctx.send({ "status": true });
	},
	// EN 02-08-2029 AP

	// SN 03-08-2029 AP | Path : update-groupline/status
	async update_status(ctx) {
		console.log(ctx.request.body);

		var id = ctx.request.body.item_id; // กลุ่ม
		var item_id = ctx.request.body.item_product_id; // product อัพเดท

		var items_status_5 = ctx.request.body.items_status_5;
		var items_status_10 = ctx.request.body.items_status_10;
		var items_status_15 = ctx.request.body.items_status_15;

		var result = await strapi.query('groupline').model.query(qb => { qb.where('id', id) }).fetchAll();
		var _resp = sanitizeEntity(result, { model: strapi.models.groupline });
		var _item = _resp[0].item;
		var _new_item = [];
		_item.forEach(products => {
			if (products.id == item_id) {

				if (items_status_5 != undefined) { products.items_status_5 = items_status_5; }
				if (items_status_10 != undefined) { products.items_status_10 = items_status_10; }
				if (items_status_15 != undefined) { products.items_status_15 = items_status_15; }

			}
			_new_item.push(products);
		});
		var dataset = {
			"id": id,
			"item": _new_item
		}
		console.log(dataset);
		strapi.query('groupline').update({ id: id }, dataset);
		ctx.send({ "status": true });
	},
	// EN 03-08-2029 AP

	// SN 03-08-2029 AP | Path : update-groupline/group
	async update_group(ctx) {
		console.log(ctx.request.body);

		var id = ctx.request.body.item_id; // กลุ่ม
		// var item_id = ctx.request.body.item_product_id; // product อัพเดท
		// ทำต่อพรุ่งนี้
		var groupline_status = ctx.request.body.groupline_status;

		var result = await strapi.query('groupline').model.query(qb => { qb.where('id', id) }).fetchAll();
		var _resp = sanitizeEntity(result, { model: strapi.models.groupline });
		// var _item = _resp[0].item;
		// var _new_item = [];
		// _item.forEach(products => {
		// 	if (products.id == item_id) {

		// 		if (items_status_5 != undefined) { products.items_status_5 = items_status_5; }

		// 	}
		// 	_new_item.push(products);
		// });
		// var dataset = {
		// 	"id": id,
		// 	"item": _new_item
		// }
		// console.log(dataset);
		// strapi.query('groupline').update({ id: id }, dataset);
		ctx.send({ "status": true });
	},
	// EN 03-08-2029 AP


	// SN 10-08-2022 AP
	async stock_groupline(ctx) {
		// input param
		var id = ctx.request.body.item_id; // กลุ่ม
		var item_id = ctx.request.body.item_product_id; // product อัพเดท
		var item_header = ctx.request.body.item_new_name; // ชื่อที่ต้องการเปลี่ยน
		var item_comment = ctx.request.body.item_comment; // ข้อความท้ายผล

		var result = await strapi.query('groupline').model.query(qb => { qb.where('id', id) }).fetchAll();
		var _resp = sanitizeEntity(result, { model: strapi.models.groupline });
		var _item = _resp[0].item;
		var _new_item = [];
		_item.forEach(products => {
			if (products.id == item_id) {
				if (item_header != undefined) {
					products.items_header = item_header; //เปลี่ยนชื่อใหม่
				} else if (item_comment != undefined) {
					products.items_comment = item_comment; //ข้อความท้ายผล
				}
			}
			_new_item.push(products);
		});
		var dataset = {
			"id": id,
			"item": _new_item
		}
		console.log(dataset);
		strapi.query('groupline').update({ id: id }, dataset);
		ctx.send({ "status": true });
	},
	// EN 10-08-2022 AP

	 

};
