/**
 *
 * ListRow
 *
 */
import React from 'react';
import PropTypes from 'prop-types';
import { ListRow as StyledListRow } from '@buffetjs/styles';

function ListRow(_ref) {
  var cells = _ref.cells,
      onClick = _ref.onClick;
  return /*#__PURE__*/React.createElement(StyledListRow, {
    onClick: onClick
  }, Object.keys(cells).map(function (key) {
    return /*#__PURE__*/React.createElement("td", {
      key: key,
      className: "".concat(key, "-cell")
    }, /*#__PURE__*/React.createElement("p", null, cells[key]));
  }));
}

ListRow.defaultProps = {
  cells: {},
  onClick: function onClick() {}
};
ListRow.propTypes = {
  cells: PropTypes.instanceOf(Object),
  onClick: PropTypes.func
};
export default ListRow;