"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _colors = _interopRequireDefault(require("../../assets/styles/colors"));

var _sizes = _interopRequireDefault(require("../../assets/styles/sizes"));

var _mixins = _interopRequireDefault(require("../../assets/styles/mixins"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n\n  /*\n  * Theme\n  */\n\n  /* General style */\n  height: ", ";\n  padding: 0 ", " ", ";\n  font-weight: ", ";\n  font-size: 1.3rem;\n  line-height: normal;\n  border-radius: ", ";\n  cursor: pointer;\n  outline: 0;\n  background-color: ", ";\n  &:hover, &:active {\n    ", ";\n  }\n  &:focus {\n    outline: 0;\n  }\n\n  \n  ", "\n\n  /* Specific style */\n  ", "\n\n  ", "\n\n  ", "\n  \n    /* FontAwesome icons */\n    > span svg {\n      font-size: 10px;\n      vertical-align: initial;\n    }\n    /* Custom icons */\n    > svg {\n      height: 10px;\n      width: auto;\n      margin-right: 10px;\n      vertical-align: baseline;\n    }\n\n\n    \n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Button = _styledComponents["default"].button(_templateObject(), _sizes["default"].button.height.large, _sizes["default"].button.padding.leftRight, _sizes["default"].button.padding.bottom, _sizes["default"].fontWeight.bold, _sizes["default"].borderRadius, _colors["default"].white, (0, _mixins["default"])(_colors["default"].lightGreyAlpha).bshadow, function (_ref) {
  var disabled = _ref.disabled;
  return disabled && "\n    &:hover {\n      box-shadow: none;\n      cursor: initial;\n    }\n    ";
}, function (_ref2) {
  var color = _ref2.color;
  return color !== 'none' && "\n      background-color: ".concat(_colors["default"].button[color].backgroundColor, ";\n      border: 1px solid ").concat(_colors["default"].button[color].borderColor, ";\n      color: ").concat(_colors["default"].button[color].color, ";\n    ");
}, function (_ref3) {
  var disabled = _ref3.disabled;
  return disabled && "\n      background-color: ".concat(_colors["default"].button.disabled.backgroundColor, ";\n      border: 1px solid ").concat(_colors["default"].button.disabled.borderColor, ";\n      color: ").concat(_colors["default"].button.disabled.color, ";\n      &:hover {\n        box-shadow: none;\n        cursor: initial;\n      }\n    ");
}, function (_ref4) {
  var color = _ref4.color;
  return color === 'success' && "\n      min-width: ".concat(_sizes["default"].button.minWidth, ";\n    ");
});

Button.defaultProps = {
  color: 'primary',
  disabled: false,
  type: 'button'
};
Button.propTypes = {
  color: _propTypes["default"].oneOf(['primary', 'secondary', 'cancel', 'success', 'delete', 'none']),
  disabled: _propTypes["default"].bool,
  type: _propTypes["default"].string
};
var _default = Button;
exports["default"] = _default;